import javax.swing.JOptionPane;
import java.text.DecimalFormat;

/**
   Chapter 5
   Programming Challenge 2 - Retail Price Calculator
*/

public class RetailPriceCalculator
{
   public static void main(String[] args)
   {
      String input;        // To hold keyboard input
      double wholesale;    // An item's wholesale cost
      double markup;       // The item's markup percentage
      
      // Get the item's wholesale cost.
      input = JOptionPane.showInputDialog("Enter the item's " +
                                          "wholesale cost.");
      wholesale = Double.parseDouble(input);
   
      // Get the item's markup percentage.
      input = JOptionPane.showInputDialog("Enter the item's " +
                                          "markup percantage.");
      markup = Double.parseDouble(input) / 100.0;

      // Create a DecimalFormat object for output formatting.
      DecimalFormat dollar = new DecimalFormat("#,##0.00");
      
      // Display the retail price.
      JOptionPane.showMessageDialog(null, "The item's retail " +
             "price is $" + 
             dollar.format(calculateRetail(wholesale, markup)));

      System.exit(0);
   }
   
   /**
      The calculateRetail method calculates an item's
      retail price.
      @param wholesale The item's wholesale price.
      @param markupPercent The item's markup percentage.
      @return The item's retail price.
   */
   
   public static double calculateRetail(double wholesale,
                                        double markupPercent)
   {
      return wholesale + (wholesale * markupPercent);
   }
}