import java.text.DecimalFormat;

/**
   Chapter 5
   Programming Challenge 6, Celsius Temperature Table
*/

public class CelsiusTable
{
   public static void main(String[] args)
   {
		// Create a DecimalFormat object to format output.
		DecimalFormat df = new DecimalFormat("0.00");
		
		// Display the table header.
		System.out.println("Fahrenheit\tCelsius");
		System.out.println("====================");
		
		// Display the table of temperatures.
		for (int fahr = 1; fahr <= 20; fahr++)
		{
			System.out.println(fahr + "\t\t" + 
	               df.format(celsius(fahr)));
		}
	}
	
	/**
		The celsius method converts a Fahrenheit temperature
		to Celsius.
		@param f The Fahrenheit temperature.
		@return The equivalent Celsius temperature.
	*/
	public static double celsius(double f)
	{
		// return 5/9(f - 32)
		return ((5.0 / 9.0) * (f - 32));
	}
}