import javax.swing.JOptionPane;
import java.text.DecimalFormat;

/**
   Chapter 5
   Programming Challenge 12, Kinetic Energy
*/

public class KineticEnergy
{
   public static void main(String[] args)
   {
      String input;        // To hold keyboard input
      double mass;         // The object's mass
      double velocity;     // The object's velocity.

      // Get the object's mass.
      input = JOptionPane.showInputDialog(
                           "Enter the object's " +
                           "mass (in kilograms).");
      mass = Double.parseDouble(input);

      // Get the object's velocity.
      input = JOptionPane.showInputDialog(
                           "Enter the object's " +
                           "velocity (in meters/second).");
      velocity = Double.parseDouble(input);

      // Create a DecimalFormat object to format output.
      DecimalFormat df = new DecimalFormat("0.00");
      
      // Display the object's kinetic energy.
      JOptionPane.showMessageDialog(null, "The object has " +
                      df.format(kineticEnergy(mass, velocity)) +
                      "Joules of kinetic energy.");
                      
      System.exit(0);
   }
   
   /**
      The kineticEnergy method calculates an object's kinetic
      energy.
      @param mass The object's mass in kilograms.
      @param velocity The object's velocity in meters per second.
      @return The object's kinetic energy, in Joules.
   */
   public static double kineticEnergy(double mass, double velocity)
   {
      // return 1.2mv^2
      return (0.5 * mass * velocity * velocity);
   }
}