import javax.swing.JOptionPane;
import java.util.Random;

/**
   Chapter 5
   Programming Challenge 17: Rock, Paper, Scissors Game
*/

public class RockPaperScissors
{
   public static void main(String[] args)
   {
		String computer;
		String user;
		
		// Get the computer's choice.
		computer = computerChoice();
		
		// Get the user's choice.
		user = userChoice();
		
		// Determine the winner.
		determineWinner(computer, user);
		
		// Exit the program.
		System.exit(0);
	}
	
	/**
		computerChoice method
		@return The computer's choice of "rock",
		        "paper", or "scissors".
	*/
	public static String computerChoice()
	{
		// Variable to hold the computer's choice.
		String choice;
		
      // Create a Random object.
      Random rand = new Random();
      
      // Generate a random number in the range of
		// 1 through 3.
      int num = rand.nextInt(3) + 1;
		
		// Determine the computer's choice where
		// 1=rock, 2=paper, and 3=scissors.
  		if (num == 1)
			choice = "rock";
		else if (num == 2)
			choice = "paper";
		else
			choice = "scissors";
			
		// Return the computer's choice.
		return choice;
	}
	
	/**
		userChoice method
		@return The user's choice of "rock",
		        "paper", or "scissors".
	*/
	public static String userChoice()
	{
		// Variable to hold the user's input.
      String input;
      
		// Get the user's choice.
      input = JOptionPane.showInputDialog(
          "Enter your choice of rock, paper, or scissors.");
		
		// Validate the choice.
		while (!isValidChoice(input))
		{
			// Get the user's choice.
      	input = JOptionPane.showInputDialog(
         	 "Please enter rock, paper, or scissors.");
		}
		
		// Return the user's choice.
		return input;
	}
	
	/**
		isValidChoice method
		@param choice A string holding the user's choice.
		@return true if the choice is valid, false otherwise.
	*/
	public static boolean isValidChoice(String choice)
	{
		// Variable to hold the validation result.
		boolean valid;
		
		if (choice.equalsIgnoreCase("rock")  ||
		    choice.equalsIgnoreCase("paper") ||
			 choice.equalsIgnoreCase("scissors"))
		{
			valid = true;
		}
		else
		{
			valid = false;
		}
		
		// Return the validation result.
		return valid;
	}
	
	/**
		The determineWinner method displays the winner.
		@param computer The computer's choice.
		@param user The user's choice.
	*/
	public static void determineWinner(String computer, String user)
	{
		// String to hold the output.
		String output;
		
		// Start building the output string with the computer's
		// and the user's choices.
		output =  "Computer's choice: " + computer + "\n";
		output += "Your choice: " + user + "\n";
		
		// Determine the winner and continue building the
		// output string.
    	if (user.equalsIgnoreCase("rock"))
    	{
        if (computer.equalsIgnoreCase("scissors"))
            output += "YOU win! Rock smashes scissors.";
        else if (computer.equalsIgnoreCase("paper"))
            output += "Computer wins! Paper wraps rock.";
        else
            output += "Tie. No winner.";
    	}
    	else if (user.equalsIgnoreCase("paper"))
    	{
        	if (computer.equalsIgnoreCase("scissors"))
            output += "Computer wins! Scissors cut paper.";
        	else if (computer.equalsIgnoreCase("rock"))
            output += "YOU win! Paper wraps rock.";
        else
            output += "Tie. No winner.";
    	}
    	else if (user.equalsIgnoreCase("scissors"))
    	{
        	if (computer.equalsIgnoreCase("rock"))
            output += "Computer win! Rock smashes scissors.";
        else if (computer.equalsIgnoreCase("paper"))
            output += "YOU win! Scissors cut paper.";
        else
            output += "Tie. No winner.";
    	}
		
		// Display the game results.
      JOptionPane.showMessageDialog(null, output);
	}
}