/**
   BankCharges Class
   Chapter 6, Programming Challenge 8
*/

public class BankCharges
{
   private final double BASE_FEE = 10.0;        // Base monthly fee
   private final double LOW_BALANCE = 400.0;    // Low balance threshold
   private final double LOW_BALANCE_FEE = 15.0; // Fee for low balance
   private int checksWritten;    // Number of checks written
   private double balance;       // Account balance

   /**
      The constructor initializes the object
      with a beginning balance and number of
      checks written.
      @param b Beginning balance.
      @param c Number of checks written.
   */

   public BankCharges(double b, int c)
   {
      balance = b;
      checksWritten = c;
   }

   /**
      The setChecksWritten method sets the
      number of checks written for a month.
      @param c The number of checks written.
   */

   public void setChecksWritten(int c)
   {
      checksWritten = c;
   }

   /**
      The setBalance method sets the account's
      balance.
      @param b The balance.
   */

   public void setBalance(double b)
   {
      balance = b;
   }

   /**
      The getChecksWritten method returns
      the number of checks written for a month.
      @return The number of checks written.
   */

   public int getChecksWritten()
   {
      return checksWritten;
   }

   /**
      The getBalance method returns the
      account balance.
      @return The account balance.
   */
   
   public double getBalance()
   {
      return balance;
   }

   /**
      The getFees method returns the amount
      of monthly fees for the account.
      @return The amount of monthly fees.
   */
   
   public double getFees()
   {
      double fees = BASE_FEE;
      
      if (balance < LOW_BALANCE)
         fees += LOW_BALANCE_FEE;
      
      if (checksWritten >= 60)
         fees += (checksWritten * 0.04);
      else if (checksWritten >= 40)
         fees += (checksWritten * 0.06);
      else if (checksWritten >= 20)
         fees += (checksWritten * 0.08);
      else
         fees += (checksWritten * 0.1);      

      return fees;
   }  
}
