import java.util.Scanner;
import java.text.DecimalFormat;

/**
   Demo program for the Payroll class
   Chapter 8, Programming Challenge 2
*/

public class PayrollDemo
{
   public static void main(String[] args)
   {
      int hours;        // Hours worked
      double payRate;   // Hourly pay rate

      // Create a Scanner object for keyboard input.
      Scanner keyboard = new Scanner(System.in);

      // Create a Payroll object.
      Payroll pr = new Payroll();
      
      // Get the hours and pay rate for each employee.
      for (int i = 0; i < pr.NUM_EMPLOYEES; i++)
      {
         // Get the hours worked.
         System.out.print("Enter the hours worked by employee " +
                          "number " + pr.getEmployeeIdAt(i) +
                          ": ");
         hours = keyboard.nextInt();
         
         // Validate hours worked.
         while (hours < 0)
         {
            System.out.print("ERROR: Enter 0 or greater for hours: ");
            hours = keyboard.nextInt();
         }
         
         // Get the hourly pay rate.
         System.out.print("Enter the hourly pay rate for employee " +
                          "number " + pr.getEmployeeIdAt(i) +
                          ": ");
         payRate = keyboard.nextDouble();
         
         // Validate pay rate.
         while (payRate < 6.0)
         {
            System.out.print("ERROR: Enter 6.00 or greater for pay rate: ");
            payRate = keyboard.nextDouble();
         }    
         
         // Store the data in the pr object.
         pr.setHoursAt(i, hours);
         pr.setPayRateAt(i, payRate);
      }
      
      // Create a DecimalFormat object to format output.
      DecimalFormat dollar = new DecimalFormat("#,##0.00");
      
      // Display the payroll data for each employee.
      System.out.println("\nPAYROLL DATA");
      System.out.println("============");
      for (int i = 0; i < pr.NUM_EMPLOYEES; i++)
      {
         System.out.println("Employee ID: " +
                            pr.getEmployeeIdAt(i));
         System.out.println("Gross pay: $" +
                            dollar.format(pr.getGrossPay(i)) +
                            "\n");
      }
   }
}

