import java.text.DecimalFormat;

/**
   RoomCarpet class
   Chapter 9, Programming Challenge 3
*/

public class RoomCarpet
{
   private RoomDimension size;   // The size of the room
   private double carpetCost;    // Carpet cost per square foot
   
   /**
      Constructor
      @param dim The room's dimensions.
      @param cost The carpet's cost per square foot.
   */

   public RoomCarpet(RoomDimension dim, double cost)
   {
      // Make size reference a copy of the object referenced
      // by the dim argument.
      size = new RoomDimension(dim.getLength(), dim.getWidth());
      
      // Assign the cost.
      carpetCost = cost;
   }
   
   /**
      getTotalCost method
      @return The total cost of the carpet.
   */
   
   public double getTotalCost()
   {
      // Return the total cost.
      return carpetCost * size.getArea();
   }

   /**
      toString method
      @return A string reporting the room's dimensions and
              the total cost of the carpet.
   */
   
   public String toString()
   {
      // Create a DecimalFormat object to format output.
      DecimalFormat dollar = new DecimalFormat("#,##0.00");
      
      // Create a String with the object state.
      String str = "Room dimensions:\n" +
                   size + "\nCarpet cost: $" +
                   dollar.format(getTotalCost());
      
      // Return the String
      return str;
   }
}
