/**
	Chapter 15
	Programming Challenge 9, Ackermann's Function
*/

public class AckermannDemo
{
	public static void main(String[] args)
	{
		System.out.println("ackermann(0, 0) = " + ackermann(0, 0));
		System.out.println("ackermann(0, 1) = " + ackermann(0, 1));
		System.out.println("ackermann(1, 1) = " + ackermann(1, 1));
		System.out.println("ackermann(1, 2) = " + ackermann(1, 2));
		System.out.println("ackermann(1, 3) = " + ackermann(1, 3));
		System.out.println("ackermann(2, 2) = " + ackermann(2, 2));
		System.out.println("ackermann(3, 2) = " + ackermann(3, 2));
	}
	
	/**
		This method implements Ackermann's Function, which
		takes two arguments, m and n.
		@param m Obviously this is the m argument.
		@param n Obviously this is the n argument.
		@return The result of Ackermann(m, n).
	*/

	public static int ackermann(int m, int n)
	{
		if (m == 0)
			return n + 1;
		else if (n == 0)
			return ackermann(m - 1, 1);
		else
			return ackermann(m - 1, ackermann(m, n - 1));
	}
}